状压DP poj 2288 Islands and Bridges

【题意】每个点有一个权值,求得分最大的路径的得分和这样的路径条数。得分规则如下

Suppose there are n islands. The value of a Hamilton path C1C2...Cn is calculated as the sum of three parts. Let Vi be the value for the island Ci. As the first part, we sum over all the Vi values for each island in the path. For the second part, for each edge CiC i+1 in the path, we add the product Vi*V i+1. And for the third part, whenever three consecutive islands CiC i+1i+2 in the path forms a triangle in the map, i.e. there is a bridge between Ci and C i+2, we add the product Vi*V i+1*V i+2

【解析】每个点的状态有前两个点决定,所以用dp[s][a][b]表示通过b到达a时的最大得分,可以有dp[s`][b][c]计算得到,s`=s^(1<<(a-1))。

【状态转移】dp[s][a][b] = max{ dp[s`][b][c] + temp }, temp = val[a] + val[a]*val[b], 如果a、c之间有边,要加上val[a]*val[b]*val[c]。

【注意】存储路径条数要用long long,因为极限数据的路径条数为13! = 3113510400。

AC代码如下:

#include "iostream"
#include "cstdio"
#include "cmath"
#include "cstring"
using namespace std;
typedef long long ll;
int val[14], dis[14][14];
ll pre[8192][14][14];
ll dp[8192][14][14];

int main()
{
    int q, n, m, x, y;
    scanf("%d",&q);
    while(q--)
    {
        scanf("%d%d",&n,&m);
        memset(dis,0,sizeof(dis));
        for(int i = 1; i <= n; i++) scanf("%d",&val[i]);
        for(int i = 0; i < m; i++)
        {
            scanf("%d%d",&x,&y);
            dis[x][y] = dis[y][x] = 1;
        }
        ll ans = -1, num = 0;
        if(n==0) { printf("0 0\n"); continue;}
        if(n==1)
        {
            printf("%d 1\n",val[1]);
            continue;
        }
        memset(dp,-1,sizeof(dp));
        memset(pre,0,sizeof(pre));
        int ns = (1<<n)-1;
        for(int s = 1; s <= ns; s++)
        {
            for(int a = 1; a <= n; a++)
            {
                if((s&(1<<(a-1)))==0) continue;
                for(int b = 1; b <= n; b++)
                {
                    if(a==b || !dis[a][b] || (s&(1<<(b-1)))==0) continue;
                    if(s == (1<<(a-1))+(1<<(b-1)))
                    {
                        dp[s][a][b] = val[a]+val[b]+val[a]*val[b];
                        pre[s][a][b] = 1;
                        continue;
                    }
                    int ts;
                    ll td;
                    for(int c = 1; c <= n; c++)
                    {
                        if(c==a || c==b || !dis[b][c] || (s&(1<<(c-1)))==0) continue;
                        ts = s^(1<<(a-1));
                        if(dp[ts][b][c] == -1 || pre[ts][b][c]==0) continue;
                        td = dp[ts][b][c] + val[a] + val[a]*val[b];
                        if(dis[a][c]) td += val[a]*val[b]*val[c];
                        if(td > dp[s][a][b])
                        {
                            dp[s][a][b] = td;
                            pre[s][a][b] = pre[ts][b][c];
                        }
                        else if(td == dp[s][a][b]) pre[s][a][b] += pre[ts][b][c];
                    }
                }
            }
        }
        for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                if(i==j || !dis[i][j] || dp[ns][i][j]==-1 || pre[ns][i][j]==0) continue;
                if(dp[ns][i][j] > ans)
                {
                    ans = dp[ns][i][j];
                    num = pre[ns][i][j];
                }
                else if(dp[ns][i][j] == ans) num += pre[ns][i][j];
            }
        }
        if(ans == -1) printf("0 0\n");
        else printf("%I64d %I64d\n",ans,num/2);
    }
    return 0;
}


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值